(in-package :om)


(defmethod real-d-val ((obj measure))
1)

(defmethod real-d-val ((obj group))
  (* 1/4 (/ (extent obj) (qvalue obj))))

(defmethod symb-d-val ((self measure))
  1)
  

(defmethod symb-d-val ((self group))
  (let* ((parent (parent self))
        (d-valp (symb-d-val parent))
        (d-valself (real-d-val self)))
    (if (= d-valp d-valself) d-valself
      (* d-valself (/ 1 d-valp)))))


(defmethod num-denom-val ((self group))
" Returns num/denum (ratio) of <self>"
  (let* ((symb-val (symb-d-val self))
         (num (get-group-ratio self)))
    (if num
        (let* ((denom (find-denom num symb-val))
              (den (if (listp denom) (list2ratio denom) denom)))
        (/ num den)) 1)))



(defmethod real-tuplet-p ((self group))
  (let ((ratio (num-denom-val self)))
    (if (= 1 ratio) nil ratio)))

(defmethod real-tuplet-p ((self chord))
  (let ((parent (parent self)))
    (when parent 
      (real-tuplet-p parent))))

(defmethod real-tuplet-p ((self rest))
  (let ((parent (parent self)))
    (when parent 
      (real-tuplet-p parent))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(in-package "MXML")




(defun time-mod-val (obj)
  (let* ((info (getallgroups obj))
        (ratios (reverse (mapcar 'butlast info)))
        (clone (om::clone ratios)))
    (om::while (and clone (equal (first (car clone)) (second (car clone))))
          (pop clone))
    (car clone)))

(defun time-modifications (self)
  (let ((ratio (time-mod-val self)))
  (if ratio 
      (group (car ratio) (second ratio))
  nil)))


(defmethod getnotetype ((self om::group))
  (let ((unite (getratiounite self)))
    (format nil "~A" (cadr (find unite *note-types* :key 'car)))
    ))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defmethod getratiogroup ((self om::group))
  (if (singelton-group? self) (list 1 1) ;;; when a group is in fact a single note 
    (let* ((allparents (reverse (cdr (getdemall self))))
           (dur (get-dur-group self))
           (num (om::get-group-ratio self))) ;;; check definition of get-group-ratio
      (if (not allparents) 
          (let* ((denom (findenom num dur)))
            (if (listp denom) denom
              (list num (findenom num dur)))) ;;; a voir !!!!!!!
        (let* ((fact (get-dur-group self))
               (ratios (loop for i in allparents
                             do (setf fact (* fact  (lst->ratio (getratiogroup i)))))) ;;; donne le facteur accumule des nested tup
               (denom (findenom num fact)))
             
          (if (listp denom) 
              denom
            (list num denom)
            )) 
        ))))

(defun getallgroups (self)
  (let* ((buf (om::parent self))
         (rep '()))
    (loop while (om::group-p buf)
          do (let ((ratiogroup (getratiogroup buf)))
               (push (list (car ratiogroup) (cadr ratiogroup) (getnotetype buf))
                     rep)
               (setf buf (om::parent buf))))
    rep))
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



(defun groupnotation (self)
  (list "<notations>"
        (if (in-group? self)
            (let* ((lvl (get-grp-level self))
                   (ratio (getratiogroup (om::parent self)))
                   (act-note (second lvl))
                   (norm-note (third lvl))
                   (indx (car lvl))
                   (numdeno (getallgroups self))
                   (numdenom (remove nil 
                                     (loop for i in numdeno
                                           collect (if (not (= 1 (/ (car i) (second i)))) i) 
                                           )))
                   (simpli (/ act-note norm-note)))

              (cond 
               ((and (om::last-of-group? self) (om::first-of-group? self));singelton
                (list (tied-notation self)
                      (when (accent? self) (list (accent-notation self)))))
               
               ((and (om::first-of-group? self) (not (om::last-of-group? self)))
                (progn 
                  (remove nil 
                          (append 
                           (let ((obj self)
                                 (indx (+ (length numdenom) 1)))
                                  
                             (remove nil (loop for i in (reverse numdenom)           
                                               append (progn 
                                                        (setf obj (om::parent obj))
                                                        (setf indx (- indx 1))
                                                        (when (and (first-of-this-group self obj) (om::real-tuplet-p self))
                                                          (firstofgroup (car i) (second i) (third i) indx))))))
                           (list (tied-notation self)
                                 (when (accent? self) (accent-notation self)))))
                  )
                )

               ((and (om::last-of-group? self) (not (om::first-of-group? self)));ici
                (remove nil 
                       
                        (append 
                         (let ((obj self)
                               (indx (+ (length numdenom) 1)))
                           (remove nil (loop for i in numdenom           
                                             append (progn 
                                                      (setf obj (om::parent obj))
                                                      (setf indx (- indx 1))
                                                      (when (and (last-of-this-group self obj) t);(time-mod-val obj))
                                                        (lastofgroup indx))))))
                         (list (tied-notation self)
                               (when (accent? self) (accent-notation self)))))
                        )
                
               (t ())))
             
           
          (when (or (tied? self) (accent? self))
            (remove nil 
                    (list 
                     (when (tied? self) (tied-notation self))
                     (when (accent? self) (accent-notation self)))))
          )
        
        ;;; VEL
        (velocity-as-xml self)
        "</notations>"
        ))



